unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, FractalImage, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    FractalImage1: TFractalImage;
    Label1: TLabel;
    Label2: TLabel;
    Button3: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Memo1: TMemo;
    cbTypes: TComboBox;
    Label6: TLabel;
    Label7: TLabel;
    ENo: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FractalImage1MouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure FractalImage1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FractalImage1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cbTypesChange(Sender: TObject);
  private
    { Private declarations }
    DownX,DownY:Integer;
    X0,Y0,X1,Y1:Double;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  FractalImage1.FractalProperties.NumberOfIterations := StrToInt(ENo.Text);
  FractalImage1.PaintFractal;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  FractalImage1.Stop;
end;

procedure TForm1.FractalImage1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  X0,Y0:Double;
begin
  FractalImage1.MapPoints(X,Y,X0,Y0);
  Label1.Caption := FloatToStr(X0);
  Label2.Caption := FloatToStr(Y0);
  if DownX <> 0 then begin
    FractalImage1.Repaint;
    FractalImage1.Canvas.DrawFocusRect(Rect(DownX,DownY,X,Y));
  end;
end;

procedure TForm1.FractalImage1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  FractalImage1.MapPoints(X,Y,X0,Y0);
  DownX := X;
  DownY := Y;
end;

procedure TForm1.FractalImage1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  DownX := 0;
  DownY := 0;
  FractalImage1.MapPoints(X,Y,X1,Y1);
  FractalImage1.FractalProperties.X0 := X0;
  FractalImage1.FractalProperties.Y0 := Y0;
  FractalImage1.FractalProperties.X1 := X1;
  FractalImage1.FractalProperties.Y1 := Y1;
  FractalImage1.PaintFractal;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  FractalImage1.RandomColors;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Label1.Caption := '';
  Label2.Caption := '';
  cbTypes.OnChange := nil;
  cbTypes.ItemIndex := Ord(FractalImage1.FractalProperties.FractalType);
  ENo.Text := IntToStr(FractalImage1.FractalProperties.NumberOfIterations);
  cbTypes.OnChange := cbTypesChange;
end;

procedure TForm1.cbTypesChange(Sender: TObject);
begin
  FractalImage1.FractalProperties.FractalType := TFractalTypes(cbTypes.ItemIndex);
  ENo.Text := IntToStr(FractalImage1.FractalProperties.NumberOfIterations);
  Button1.Click;
end;

end.
